#include "lua.h"
#include <stdio.h>
#include "io.h"
#include <stdlib.h>
#include <string.h>
#include "lua5.4/lua.h"
#include "types/str.h"
#include "types/parray.h"

static int ii = 0;
static int malloc_count = 0;

void* __malloc_(size_t N){
    printf("hi");
    malloc_count++;
    return (malloc)(N);
}

void __free_(void* p){
    malloc_count--;
    printf("%i\n",malloc_count);
    return (free)(p);
}

int writer(lua_State *L, const void* p, size_t sz, void* ud){
    char o[2] = {0};
    for (int i =0; i<sz; i++){
        //printf("%c\n",((char*)p)[i]);
        o[0] = ((char*)p)[i];
        str_pushl((str*)ud, o, 1);
        //printf("%s\n",((str*)ud)->c);
    }
    
    return 0;
}

/**
 * @brief copy top element from src to dest
 *
 * @param {lua_State*} source
 * @param {lua_State*} dest
 * @param {void*} items already visited, use NULL
*/
void i_dcopy(lua_State* src, lua_State* dest, void* _seen){
    parray_t* seen = (parray_t*)_seen;
    int wnull = seen == NULL;
    if(wnull) seen = parray_init();
    size_t len;
    //printf("%i\n",seen->len);
    int at, at2;
    //int *sp = malloc(1);
    //int *sp;
    char* s;
    void* whar;
    double n;
    int old_top = lua_gettop(src);
    //printf("%i\n",ii++);
    switch(lua_type(src, -1)){
        case LUA_TNUMBER:
            n = luaL_checknumber(src, -1);
            if(n == (int)n) lua_pushinteger(dest, (int)n);
            else lua_pushnumber(dest, n);
            break;
        case LUA_TSTRING:
            s = (char*)luaL_checklstring(src, -1, &len);
            lua_pushlstring(dest, s, len);
            break;
        case LUA_TTABLE:
            lua_newtable(dest);
            at = lua_gettop(dest);
            at2 = lua_gettop(src);
            char aauwu[50] = {0};
            sprintf(aauwu, "%p", lua_topointer(src, at2));

            //int* sp = malloc(1);
            whar = parray_get(seen, aauwu);
            if( whar != NULL){
                //printf("%s\n",lua_tostring(src, at2 - 1));
                //printf("WHAR\n");
                lua_pop(dest, 1);
                lua_rawgeti(dest, LUA_REGISTRYINDEX, *(int*)whar);

                
                return;
            }
            int *sp = malloc(sizeof * sp);

            //lua_pushinteger(dest, 55);
            int r = luaL_ref(dest, LUA_REGISTRYINDEX);
            lua_rawgeti(dest, LUA_REGISTRYINDEX, r);
            *sp = r;
            parray_set(seen, aauwu, sp);
            //printf("saved %i\n", *sp);

            //for(int i = 0; i != seen->len; i++){
            //    printf("%i ", *(int*)seen->P[i].value);
            //}
            lua_pushnil(src);
            for(;lua_next(src, at2) != 0;){
                lua_pushvalue(src, -2);
                int a = lua_gettop(src);
                //l_pprint(src);
                lua_settop(src, a);
                i_dcopy(src, dest, seen);

                lua_pushvalue(src, -2);
                i_dcopy(src, dest, seen);
                
                lua_settable(dest, at);
                lua_pop(src, 3);
            }
            //printf("done\n");
            //lua_settop(dest, at);
            break;
        case LUA_TFUNCTION:
            if(lua_iscfunction(src, old_top)){
                //kinda silly
                lua_pushcfunction(dest, lua_tocfunction(src, -1));
                break;
            }
            
            str* awa = str_init("");
            lua_dump(src, writer, (void*)awa, 0);
            lua_pushlstring(dest, awa->c, awa->len);

            luaL_loadbuffer(dest, awa->c, awa->len, awa->c);
            lua_remove(dest, -2);
            str_free(awa);
            //lua_pushvalue(dest, -1);
            break;
        case LUA_TUSERDATA:
        case LUA_TLIGHTUSERDATA:
            lua_pushlightuserdata(dest, lua_touserdata(src, -1));
            int tidx = lua_gettop(dest);

            if(lua_getmetatable(src, -1)){
                //int a = lua_gettop(src);
                //l_pprint(src);
                //lua_settop(src, a);
                //printf("**--**\n");
                i_dcopy(src, dest, seen);
                //int a = lua_gettop(dest);
                //l_pprint(dest);
                //lua_settop(dest, a);
                lua_setmetatable(dest, tidx);
                lua_pop(src, 1);
            }
            lua_settop(dest, tidx);
            //printf("aww\n");
            //lua_pushnumber(dest, 8);
            break;
        default:
            printf("%i\n",lua_type(src, -1));
            lua_pushnil(dest);
            break;
    }
    if(wnull) parray_clear(seen, FREE);
    //lua_settop(src, old_top);
    _seen = seen;
}

/**
 * @brief extracts a table to be global
 *
 * @param {lua_State*} source
*/
void lua_set_global_table(lua_State* L){
  lua_pushnil(L);
  for(;lua_next(L, -2) != 0;){
    lua_setglobal(L, lua_tostring(L, -2));
  }
}

